## libsdl3-mixer 3~git20250214~bc9c365+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.28)

if(NOT DEFINED CMAKE_BUILD_TYPE)
  set(cmake_build_type_undefined 1)
endif()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")

# See docs/release_checklist.md
set(MAJOR_VERSION 3)
set(MINOR_VERSION 0)
set(MICRO_VERSION 0)
set(SDL_REQUIRED_VERSION 3.0.0)

project(SDL3_mixer
    LANGUAGES C
    VERSION "${MAJOR_VERSION}.${MINOR_VERSION}.${MICRO_VERSION}"
)

include("${SDL3_mixer_SOURCE_DIR}/cmake/GetGitRevisionDescription.cmake")
include("${SDL3_mixer_SOURCE_DIR}/cmake/PrivateSdlFunctions.cmake")
include("${SDL3_mixer_SOURCE_DIR}/cmake/sdlcpu.cmake")
include("${SDL3_mixer_SOURCE_DIR}/cmake/sdlmanpages.cmake")
include("${SDL3_mixer_SOURCE_DIR}/cmake/sdlplatform.cmake")
sdl_calculate_derived_version_variables(${MAJOR_VERSION} ${MINOR_VERSION} ${MICRO_VERSION})

message(STATUS "Configuring ${PROJECT_NAME} ${PROJECT_VERSION}")

if(CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR)
    set(SDLMIXER_ROOTPROJECT ON)
else()
    set(SDLMIXER_ROOTPROJECT OFF)
endif()

# By default, configure in RelWithDebInfo configuration
if(SDLMIXER_ROOTPROJECT)
  get_property(is_multi_config GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
  if(is_multi_config)
    # The first item in CMAKE_CONFIGURATION_TYPES is the default configuration
    if(DEFINED CMAKE_CONFIGURATION_TYPES AND "RelWithDebInfo" IN_LIST CMAKE_CONFIGURATION_TYPES)
      list(REMOVE_ITEM CMAKE_CONFIGURATION_TYPES "RelWithDebInfo")
      list(INSERT CMAKE_CONFIGURATION_TYPES 0 "RelWithDebInfo")
      set(CMAKE_CONFIGURATION_TYPES "${CMAKE_CONFIGURATION_TYPES}" CACHE STRING "CMake configuration types" FORCE)
    endif()
  else()
    if(cmake_build_type_undefined)
      set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "CMake build type" FORCE)
    endif()
  endif()
endif()

set(SDLMIXER_SAMPLES_DEFAULT ${SDLMIXER_ROOTPROJECT})
if(ANDROID)
    set(SDLMIXER_SAMPLES_DEFAULT OFF)
endif()

# option() honors normal variables.
cmake_policy(SET CMP0077 NEW)
set(CMAKE_POLICY_DEFAULT_CMP0077 NEW)

if(POLICY CMP0112)
    # Target file component generator expressions do not add target dependencies.
    cmake_policy(SET CMP0112 NEW)
endif()

if(POLICY CMP0099)
    # Make `INTERFACE_LINK_DIRECTORIES` a transitive usage requirement.
    # This is needed for static dependencies which have transitive dependencies
    # outside of compiler default search paths.
    cmake_policy(SET CMP0099 NEW)
endif()

# Assume MSVC projects don't have a package manager and need vendored dependencies (by default).
# Most other platforms have some kind of package manager.
# FIXME: consider a package manager such as conan/vcpkg instead of vendoring
if(ANDROID OR MSVC)
    set(vendored_default ON)
else()
    set(vendored_default OFF)
endif()

set(sdl3mixer_install_enableable ON)
if((TARGET SDL3-shared OR TARGET SDL3-static) AND SDL_DISABLE_INSTALL)
    # Cannot install SDL3_mixer when SDL3 is built in same built, and is not installed.
    set(sdl3mixer_install_enableable OFF)
endif()

if(NOT DEFINED CMAKE_FIND_PACKAGE_PREFER_CONFIG)
    set(CMAKE_FIND_PACKAGE_PREFER_CONFIG ON)
endif()

include(CheckIncludeFile)
include(CheckSymbolExists)
include(CMakeDependentOption)
include(CMakePackageConfigHelpers)
include(GNUInstallDirs)
include(PkgConfigHelper)

set(PLATFORM_SUPPORTS_SHARED ON)
if(EMSCRIPTEN OR VITA OR PSP OR PS2 OR N3DS OR RISCOS)
  set(PLATFORM_SUPPORTS_SHARED OFF)
endif()

option(CMAKE_POSITION_INDEPENDENT_CODE "Build static libraries with -fPIC" ${PLATFORM_SUPPORTS_SHARED})
cmake_dependent_option(BUILD_SHARED_LIBS "Build the library as a shared library" ON PLATFORM_SUPPORTS_SHARED OFF)

cmake_dependent_option(SDLMIXER_INSTALL "Enable SDL3mixer install target" ${SDLMIXER_ROOTPROJECT} "${sdl3mixer_install_enableable}" OFF)
cmake_dependent_option(SDLMIXER_INSTALL_CPACK "Create binary SDL3_mixer archive using CPack" ${SDLMIXER_ROOTPROJECT} "SDLMIXER_INSTALL" OFF)
cmake_dependent_option(SDLMIXER_INSTALL_MAN "Install man pages for SDL3_mixer" OFF "SDLMIXER_INSTALL" OFF)
cmake_dependent_option(SDLMIXER_DEPS_SHARED "Load dependencies dynamically" ON PLATFORM_SUPPORTS_SHARED OFF)
cmake_dependent_option(SDLMIXER_RELOCATABLE "Create relocatable SDL_mixer package" "${MSVC}" SDLMIXER_INSTALL OFF)
option(SDLMIXER_VENDORED "Use vendored third-party libraries" ${vendored_default})
option(SDLMIXER_WERROR "Treat warnings as errors" OFF)

option(SDLMIXER_STRICT "Fail when a dependency could not be found" OFF)
set(required "")
set(fatal_error "STATUS")
if(SDLMIXER_STRICT)
  set(required "REQUIRED")
  set(fatal_error "FATAL_ERROR")
endif()

option(SDLMIXER_SAMPLES "Build the SDL3_mixer sample program(s)" ${SDLMIXER_SAMPLES_DEFAULT})
cmake_dependent_option(SDLMIXER_SAMPLES_INSTALL "Install the SDL3_mixer sample program(s)" OFF "SDLMIXER_SAMPLES;SDLMIXER_INSTALL" OFF)

option(SDLMIXER_SNDFILE "Support loading sounds via libsndfile" OFF)
option(SDLMIXER_SNDFILE_SHARED "Dynamically load libsndfile" "${SDLMIXER_DEPS_SHARED}")

option(SDLMIXER_FLAC "Enable FLAC music" ON)

cmake_dependent_option(SDLMIXER_FLAC_LIBFLAC "Enable FLAC music using libFLAC" OFF SDLMIXER_FLAC OFF)
cmake_dependent_option(SDLMIXER_FLAC_LIBFLAC_SHARED "Dynamically load LIBFLAC" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_FLAC_LIBFLAC OFF)

cmake_dependent_option(SDLMIXER_FLAC_DRFLAC "Enable FLAC music using drflac" ON SDLMIXER_FLAC OFF)

option(SDLMIXER_GME "Support loading GME music via game-music-emu" ON)
option(SDLMIXER_GME_SHARED "Dynamically load libgme" "${SDLMIXER_DEPS_SHARED}")

option(SDLMIXER_MOD "Support loading MOD music" ON)

cmake_dependent_option(SDLMIXER_MOD_MODPLUG "Support loading MOD music via modplug" OFF SDLMIXER_MOD OFF)
cmake_dependent_option(SDLMIXER_MOD_MODPLUG_SHARED "Dynamically load modplug" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_MOD_MODPLUG OFF)

cmake_dependent_option(SDLMIXER_MOD_XMP "Support loading MOD music via libxmp" ON SDLMIXER_MOD OFF)
cmake_dependent_option(SDLMIXER_MOD_XMP_LITE "Use libxmp-lite instead of libxmp" OFF "SDLMIXER_MOD_XMP;NOT SDLMIXER_VENDORED" OFF)
cmake_dependent_option(SDLMIXER_MOD_XMP_SHARED "Dynamically load libxmp(-lite)" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_MOD_XMP OFF)

if(SDLMIXER_MOD AND NOT (SDLMIXER_MOD_MODPLUG OR SDLMIXER_MOD_XMP))
    message(FATAL_ERROR "MOD support was enabled (SDLMIXER_MOD) but neither modplug (SDLMIXER_MOD_MODPLUG) or xmp (SDLMIXER_MOD_XMP) was enabled.")
endif()

option(SDLMIXER_MP3 "Enable MP3 music" ON)

cmake_dependent_option(SDLMIXER_MP3_MINIMP3 "Support loading MP3 music via minimp3" ON SDLMIXER_MP3 OFF)

cmake_dependent_option(SDLMIXER_MP3_MPG123 "Support loading MP3 music via MPG123" OFF SDLMIXER_MP3 OFF)
cmake_dependent_option(SDLMIXER_MP3_MPG123_SHARED "Dynamically load mpg123" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_MP3_MPG123 OFF)

if(SDLMIXER_MP3 AND NOT (SDLMIXER_MP3_MINIMP3 OR SDLMIXER_MP3_MPG123))
    message(FATAL_ERROR "MP3 support was enabled (SDLMIXER_MP3) but neither minimp3 (SDLMIXER_MP3_MINIMP3) or mpg123 (SDLMIXER_MP3_MPG123) were enabled.")
endif()

option(SDLMIXER_MIDI "Enable MIDI music" ON)

cmake_dependent_option(SDLMIXER_MIDI_FLUIDSYNTH "Support FluidSynth MIDI output" ON "SDLMIXER_MIDI;NOT SDLMIXER_VENDORED" OFF)
cmake_dependent_option(SDLMIXER_MIDI_FLUIDSYNTH_SHARED "Dynamically load libfluidsynth" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_MIDI_FLUIDSYNTH OFF)

if(WIN32 OR APPLE OR HAIKU OR "${CMAKE_SYSTEM_NAME}" MATCHES "Linux")
    cmake_dependent_option(SDLMIXER_MIDI_NATIVE "Support native MIDI output" ON SDLMIXER_MIDI OFF)
else()
    set(SDLMIXER_MIDI_NATIVE OFF)
endif()

cmake_dependent_option(SDLMIXER_MIDI_TIMIDITY "Support timidity MIDI output" ON SDLMIXER_MIDI OFF)

if(SDLMIXER_MIDI AND NOT (SDLMIXER_MIDI_TIMIDITY OR SDLMIXER_MIDI_NATIVE OR SDLMIXER_MIDI_FLUIDSYNTH))
    message(FATAL_ERROR "MIDI support was enabled (SDLMIXER_MIDI) but neither FluidSynth (SDLMIXER_MIDI_FLUIDSYNTH), native (SDLMIXER_MIDI_NATIVE) or timidity (SDLMIXER_MIDI_TIMIDITY) was enabled")
endif()

option(SDLMIXER_OPUS "Enable Opus music" ON)
cmake_dependent_option(SDLMIXER_OPUS_SHARED "Dynamically load libopus" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_OPUS OFF)

set(sdl3mixer_vorbis_strings STB TREMOR VORBISFILE)
set(SDLMIXER_VORBIS "STB" CACHE STRING "Enable OGG Vorbis music")
set_property(CACHE SDLMIXER_VORBIS PROPERTY STRINGS "${sdl3mixer_vorbis_strings}")
if(SDLMIXER_VORBIS)
    if(NOT SDLMIXER_VORBIS IN_LIST sdl3mixer_vorbis_strings)
        message(FATAL_ERROR "SDLMIXER_VORBIS contains an invalid value (=${SDLMIXER_VORBIS}). It must be one of ${sdl3mixer_vorbis_strings}.")
    endif()
endif()
set(SDLMIXER_VORBIS_STB OFF)
set(SDLMIXER_VORBIS_TREMOR OFF)
set(SDLMIXER_VORBIS_VORBISFILE OFF)
if(SDLMIXER_VORBIS STREQUAL "STB")
    set(SDLMIXER_VORBIS_STB ON)
endif()
if(SDLMIXER_VORBIS STREQUAL "TREMOR")
    set(SDLMIXER_VORBIS_TREMOR ON)
endif()
if(SDLMIXER_VORBIS STREQUAL "VORBISFILE")
    set(SDLMIXER_VORBIS_VORBISFILE ON)
endif()
cmake_dependent_option(SDLMIXER_VORBIS_TREMOR_SHARED "Dynamically load tremor library" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_VORBIS_TREMOR OFF)
cmake_dependent_option(SDLMIXER_VORBIS_VORBISFILE_SHARED "Dynamically load vorbisfile library" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_VORBIS_VORBISFILE OFF)

option(SDLMIXER_WAVE "Enable streaming WAVE music" ON)

option(SDLMIXER_WAVPACK "Enable WavPack music" ON)
cmake_dependent_option(SDLMIXER_WAVPACK_DSD "Enable WavPack DSD music support" OFF SDLMIXER_WAVPACK OFF)
cmake_dependent_option(SDLMIXER_WAVPACK_SHARED "Dynamically load WavPack library" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_WAVPACK OFF)

if(SDLMIXER_VORBIS_TREMOR OR SDLMIXER_VORBIS_VORBISFILE OR SDLMIXER_FLAC_LIBFLAC OR SDLMIXER_OPUS)
    set(SDLMIXER_OGG TRUE)
    set(SDLMIXER_OGG_install FALSE)
    if(SDLMIXER_VORBIS_VORBISFILE_SHARED OR SDLMIXER_FLAC_SHARED OR SDLMIXER_OPUS_SHARED)
        set(SDLMIXER_OGG_SHARED TRUE)
        set(SDLMIXER_OGG_install TRUE)
    else()
        set(SDLMIXER_OGG_SHARED FALSE)
        if(NOT SDLMIXER_BUILD_SHARED_LIBS)
            set(SDLMIXER_OGG_install TRUE)
        endif()
    endif()
else()
    set(SDLMIXER_OGG FALSE)
endif()

# Save BUILD_SHARED_LIBS variable
set(SDLMIXER_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})

set(sdl_required_components Headers)

if(SDLMIXER_BUILD_SHARED_LIBS)
    set(sdl3_mixer_target_name SDL3_mixer-shared)
    set(sdl3_target_name SDL3::SDL3-shared)

    list(APPEND sdl_required_components SDL3-shared)
else()
    set(sdl3_mixer_target_name SDL3_mixer-static)
    set(sdl3_target_name SDL3::SDL3)
endif()

if(NOT TARGET SDL3::Headers OR NOT TARGET ${sdl3_target_name})
    find_package(SDL3 ${SDL_REQUIRED_VERSION} REQUIRED COMPONENTS ${sdl_required_components})
endif()

SDL_DetectTargetCPUArchitectures(SDL_CPU_NAMES)
SDL_DetectCMakePlatform()

set(BUILD_SHARED_LIBS ${SDLMIXER_BUILD_SHARED_LIBS})
add_library(${sdl3_mixer_target_name}
    src/codecs/load_aiff.c
    src/codecs/load_voc.c
    src/codecs/load_sndfile.c
    src/codecs/mp3utils.c
    src/codecs/music_drflac.c
    src/codecs/music_flac.c
    src/codecs/music_fluidsynth.c
    src/codecs/music_gme.c
    src/codecs/music_minimp3.c
    src/codecs/music_modplug.c
    src/codecs/music_mpg123.c
    src/codecs/music_nativemidi.c
    src/codecs/music_ogg.c
    src/codecs/music_ogg_stb.c
    src/codecs/music_opus.c
    src/codecs/music_timidity.c
    src/codecs/music_wav.c
    src/codecs/music_wavpack.c
    src/codecs/music_xmp.c
    src/effect_position.c
    src/effect_stereoreverse.c
    src/effects_internal.c
    src/mixer.c
    src/music.c
    src/utils.c
)
add_library(SDL3_mixer::${sdl3_mixer_target_name} ALIAS ${sdl3_mixer_target_name})
if(NOT TARGET SDL3_mixer::SDL3_mixer)
    add_library(SDL3_mixer::SDL3_mixer ALIAS ${sdl3_mixer_target_name})
endif()
target_include_directories(${sdl3_mixer_target_name}
    PUBLIC
        "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
    PRIVATE
        src
        src/codecs
)
target_compile_definitions(${sdl3_mixer_target_name} PRIVATE
    BUILD_SDL

## libsdl3-mixer 3~git20250214~bc9c365%2Bds

=== debian/changelog ===
libsdl3-mixer (3~git20250214~bc9c365+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/copyright: Update
  * d/control, d/copyright: Update upstream project URLs
  * d/control: Require SDL 3.2.0 stable release

 -- Simon McVittie <smcv@debian.org>  Mon, 17 Feb 2025 10:58:15 +0000

libsdl3-mixer (3~git20250203~ebdd9cc+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/copyright: Update
  * d/watch*: Sync with SDL_image, SDL_ttf

 -- Simon McVittie <smcv@debian.org>  Mon, 03 Feb 2025 13:59:38 +0000

libsdl3-mixer (3~git20250123~723ad21+ds-1) experimental; urgency=medium

  * New upstream snapshot

 -- Simon McVittie <smcv@debian.org>  Fri, 24 Jan 2025 12:21:02 +0000

libsdl3-mixer (3~git20250112~1bf7a79+ds-1) experimental; urgency=medium

  * New upstream snapshot, corresponding to SDL3 3.1.10 prerelease
  * d/salsa-ci.yml: Add

 -- Simon McVittie <smcv@debian.org>  Sun, 19 Jan 2025 17:25:50 +0000

libsdl3-mixer (3~git20250107~4870186+ds-1) experimental; urgency=medium

  * New upstream snapshot, corresponding to SDL3 3.1.8 prerelease
  * d/copyright: Update

 -- Simon McVittie <smcv@debian.org>  Wed, 08 Jan 2025 16:27:16 +0000

libsdl3-mixer (3~git20241102~5e2a705+ds-1) experimental; urgency=medium

  * New upstream snapshot, corresponding to SDL3 3.1.6 prerelease
  * d/rules, d/libsdl3-mixer0.symbols:
    Music playback via an arbitrary external command is no longer supported

 -- Simon McVittie <smcv@debian.org>  Mon, 04 Nov 2024 18:38:47 +0000

libsdl3-mixer (3~git20240925~e32ba24+ds-1) experimental; urgency=medium

  * New upstream snapshot, corresponding to SDL3 3.1.3 prerelease
  * d/control: Build-depend on a contemporary SDL3
  * d/p/Update-for-rename-of-SDL3-atomic-int-APIs.patch:
    Drop patch, applied upstream

 -- Simon McVittie <smcv@debian.org>  Fri, 04 Oct 2024 18:09:14 +0100

libsdl3-mixer (3~git20240915~809804e+ds-1) experimental; urgency=medium

  * New upstream snapshot
    - d/control: (Build-)Depend on a corresponding libsdl3 snapshot
  * d/p/Update-for-rename-of-SDL3-atomic-int-APIs.patch:
    Add proposed patch for compatibility with latest SDL3
  * d/tests: playwave now needs the SDL3_test library

 -- Simon McVittie <smcv@debian.org>  Tue, 17 Sep 2024 21:15:26 +0100

libsdl3-mixer (3~git20240828~36b1c88+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/libsdl3-mixer0.symbols: Remove obsolete symbols
  * d/rules: Update build option names
  * Standards-Version: 4.7.0 (no changes required)

 -- Simon McVittie <smcv@debian.org>  Tue, 03 Sep 2024 21:29:31 +0100

libsdl3-mixer (3~git20240730~623ef30+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/control: (Build-)Depend on a corresponding libsdl3 snapshot
  * d/libsdl3-mixer0.symbols: Update
  * Update list of man pages to install

 -- Simon McVittie <smcv@debian.org>  Tue, 30 Jul 2024 17:20:20 +0100

libsdl3-mixer (3~git20240508~c2fe2a6+ds-1) experimental; urgency=medium

  * New upstream snapshot, corresponding to SDL 3.1.2
    - Depend on a corresponding SDL3 prerelease
  * d/rules: Build man pages if and only if -doc package is built

 -- Simon McVittie <smcv@debian.org>  Thu, 20 Jun 2024 14:52:34 +0100

libsdl3-mixer (3~git20240319~12fb85e+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * Depend on a corresponding SDL3 prerelease
  * d/libsdl3-mixer0.symbols: Update for upstream ABI breaks

 -- Simon McVittie <smcv@debian.org>  Mon, 25 Mar 2024 18:43:56 +0000

libsdl3-mixer (3~git20240121~3c8461d+ds-1) experimental; urgency=medium

  * New upstream snapshot

 -- Simon McVittie <smcv@debian.org>  Mon, 22 Jan 2024 12:35:01 +0000

libsdl3-mixer (3~git20240115~9eae94f+ds-1) experimental; urgency=medium

  * New upstream snapshot
    - d/copyright: Exclude vendored minimp3, not used in Debian

 -- Simon McVittie <smcv@debian.org>  Mon, 15 Jan 2024 18:07:37 +0000

libsdl3-mixer (3~git20240101~de0f62a+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/copyright: Update

 -- Simon McVittie <smcv@debian.org>  Tue, 02 Jan 2024 17:32:49 +0000

libsdl3-mixer (3~git20231205~1d30b08+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/libsdl3-mixer0.symbols: Update

 -- Simon McVittie <smcv@debian.org>  Thu, 07 Dec 2023 20:11:58 +0000

libsdl3-mixer (3~git20230930~92f0574+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/rules: Use package version instead of trying to get version from git

 -- Simon McVittie <smcv@debian.org>  Mon, 02 Oct 2023 14:53:10 +0100

libsdl3-mixer (3~git20230921~5ce3f92+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/libsdl3-mixer0.symbols: Update
  * Drop the only patch, applied upstream

 -- Simon McVittie <smcv@debian.org>  Thu, 28 Sep 2023 17:25:31 +0100

libsdl3-mixer (3~git20230913~d7e4f19+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/control: Bump (build-)dependency on SDL3 for audio API changes
  * d/rules: Make dependency checks strict.
    When we enable a backend, we want the build to fail if it wasn't found.
  * d/.gitignore: Disable an overzealous rule in /.gitignore
  * d/p/build-Fix-detection-of-libvorbisfile.patch:
    Add proposed patch to fix detection of libvorbisfile

 -- Simon McVittie <smcv@debian.org>  Tue, 19 Sep 2023 20:00:57 +0100

libsdl3-mixer (3~git20230904~dc93c43+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/.gitignore: Also ignore d/libsdl3-mixer-doc/
  * Depend on a corresponding version of SDL3 to follow API changes

 -- Simon McVittie <smcv@debian.org>  Mon, 04 Sep 2023 22:17:38 +0100

libsdl3-mixer (3~git20230810~ec99350+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/.gitignore: Update for SDL3
  * d/watch: Use a +ds suffix for the orig tarball.
    To the best of my knowledge, everything we exclude is (meant to be)
    Free Software, we just don't want to keep track of files that are


=== debian/control ===
Source: libsdl3-mixer
Section: libs
Priority: optional
Maintainer: Debian SDL packages maintainers <pkg-sdl-maintainers@lists.alioth.debian.org>
Uploaders: Manuel A. Fernandez Montecelo <mafm@debian.org>, Simon McVittie <smcv@debian.org>
Standards-Version: 4.7.0
Rules-Requires-Root: no
Build-Depends: cmake,
               debhelper-compat (= 13),
               libflac-dev,
               libmpg123-dev,
               libogg-dev,
               libopusfile-dev,
               libsdl3-dev (>= 3.2.0),
               libvorbis-dev,
               pkgconf
Homepage: https://github.com/libsdl-org/SDL_mixer
Vcs-Browser: https://salsa.debian.org/sdl-team/libsdl3-mixer
Vcs-Git: https://salsa.debian.org/sdl-team/libsdl3-mixer.git


Package: libsdl3-mixer0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Mixer library for Simple DirectMedia Layer 3, libraries
 SDL_mixer is a sample multi-channel audio mixer library.  It supports any
 number of simultaneously playing channels of 16 bit stereo audio, plus a single
 channel of music, in various formats including FLAC, Ogg Vorbis, Opus, MP3 and
 WAV.
 .
 This package contains the shared library.

Package: libsdl3-mixer-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         libflac-dev,
         libmpg123-dev,
         libogg-dev,
         libopusfile-dev,
         libsdl3-dev (>= 3.2.0),
         libsdl3-mixer0 (= ${binary:Version}),
         libvorbis-dev,
Description: Mixer library for Simple DirectMedia Layer 3, development files
 SDL_mixer is a sample multi-channel audio mixer library.  It supports any
 number of simultaneously playing channels of 16 bit stereo audio, plus a single
 channel of music, in various formats including FLAC, Ogg Vorbis, Opus, MP3 and
 WAV.
 .
 This package contains the development files.

Package: libsdl3-mixer-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends:
 ${misc:Depends},
Description: Mixer library for Simple DirectMedia Layer 3 - documentation
 SDL_mixer is a sample multi-channel audio mixer library.  It supports any
 number of simultaneously playing channels of 16 bit stereo audio, plus a single
 channel of music, in various formats including FLAC, Ogg Vorbis, Opus, MP3 and
 WAV.
 .
 This package contains the reference manual and examples.

Package: libsdl3-mixer-tests
Build-Profiles: <!noinsttest>
Architecture: any
Section: misc
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libsdl3-mixer0 (= ${binary:Version}),
Description: Mixer library for Simple DirectMedia Layer 3 - tests
 SDL_mixer is a sample multi-channel audio mixer library.  It supports any
 number of simultaneously playing channels of 16 bit stereo audio, plus a single
 channel of music, in various formats including FLAC, Ogg Vorbis, Opus, MP3 and
 WAV.
 .
 This package contains manual tests. Automated tests will be added to this
 package if they become available upstream.

## libsdl3-mixer 3~git20250214~bc9c365+ds

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

export DEB_CFLAGS_MAINT_APPEND  := -pipe -Wall

# TODO: We will need this if we re-enable MIDI playback:
# bug #715461, provide default soundfont paths
#export DEB_CPPFLAGS_MAINT_APPEND := -DMIX_INIT_SOUNDFONT_PATHS="\"/usr/share/sounds/sf3/default-GM.sf3\""

include /usr/share/dpkg/default.mk

built_binaries := $(shell dh_listpackages)

ifneq (,$(filter-out experimental UNRELEASED,$(DEB_DISTRIBUTION)))
$(error This version of SDL_image is not yet suitable for testing/unstable)
endif

confflags :=
confflags += -DSDLMIXER_DEPS_SHARED=OFF
confflags += -DSDLMIXER_STRICT=ON
confflags += -DSDLMIXER_VENDORED=OFF
confflags += -DSDLMIXER_WERROR=OFF

ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS))$(filter %-tests,$(built_binaries)),nocheck)
confflags += -DSDLMIXER_TESTS=ON
endif

ifneq ($(filter %-doc,$(built_binaries)),)
confflags += -DSDLMIXER_INSTALL_MAN=ON
endif

ifneq ($(filter %-tests,$(built_binaries)),)
confflags += -DSDLMIXER_SAMPLES=ON
confflags += -DSDLMIXER_SAMPLES_INSTALL=ON
confflags += -DSDLMIXER_TESTS_INSTALL=ON
endif

confflags += -DSDLMIXER_FLAC=ON
confflags += -DSDLMIXER_FLAC_LIBFLAC=ON
confflags += -DSDLMIXER_FLAC_DRFLAC=OFF

# gme has caused security issues in the past, so the conservative approach
# is to leave it switched off until someone needs it
confflags += -DSDLMIXER_GME=OFF

# Enabling a previously disabled format is more compatible than disabling a
# previously enabled format, so initially turn off MIDI for the SDL3 branch.
confflags += -DSDLMIXER_MIDI=OFF
# Historically we enabled both fluidsynth and timidity by default, but it's
# not clear that it was useful to do so.
confflags += -DSDLMIXER_MIDI_FLUIDSYNTH=OFF
confflags += -DSDLMIXER_MIDI_NATIVE=OFF
confflags += -DSDLMIXER_MIDI_TIMIDITY=OFF

# Enabling a previously disabled format is more compatible than disabling a
# previously enabled format, so initially turn off soundtracker playback
# for the SDL3 branch.
confflags += -DSDLMIXER_MOD=OFF
confflags += -DSDLMIXER_MOD_MODPLUG=OFF
confflags += -DSDLMIXER_MOD_XMP=OFF
confflags += -DSDLMIXER_MOD_XMP_LITE=OFF

confflags += -DSDLMIXER_MP3=ON
confflags += -DSDLMIXER_MP3_MPG123=ON
confflags += -DSDLMIXER_MP3_MINIMP3=OFF

confflags += -DSDLMIXER_OPUS=ON
confflags += -DSDLMIXER_SNDFILE=OFF
confflags += -DSDLMIXER_VORBIS=VORBISFILE
confflags += -DSDLMIXER_WAVE=ON

# Enabling a previously disabled format is more compatible than disabling a
# previously enabled format, so initially turn off wavpack for the SDL3
# branch.
confflags += -DSDLMIXER_WAVPACK=OFF

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	echo "$(DEB_VERSION_UPSTREAM_REVISION)" > VERSION.txt
	dh_auto_configure -- $(confflags)

override_dh_installchangelogs:
	dh_installchangelogs -- CHANGES.txt

override_dh_compress:
	dh_compress -Xplaymus.c -Xplaywave.c

# debhelper >= 13.4 makes all of /usr/libexec executable, which is not
# quite right for installed-tests
override_dh_fixperms:
	dh_fixperms -Xusr/libexec/installed-tests
ifneq ($(filter %-tests,$(built_binaries)),)
	chmod --recursive --changes a+rX,u+w,og-w debian/*-tests/usr/libexec/installed-tests
endif

=== debian/watch ===
version=4

opts="\
    mode=git, \
    compression=gzip, \
    dversionmangle=s/\+(?:git)?[0-9]*(?:\+g[0-9a-f]*)(?:\+(?:dfsg|ds)[0-9]*)//, \
    pretty=3~git%cd~%h+ds" \
https://github.com/libsdl-org/SDL_mixer \
HEAD

## libsdl3-mixer 3~git20250226~39d11cd+ds

=== debian/changelog ===
libsdl3-mixer (3~git20250226~39d11cd+ds-1) experimental; urgency=medium

  * New upstream snapshot

 -- Simon McVittie <smcv@debian.org>  Fri, 28 Feb 2025 13:52:56 +0000

## libsdl3-mixer 3~git20250610~30c1301+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.16...3.28)
+cmake_minimum_required(VERSION 3.16...4.0)
 
 if(NOT DEFINED CMAKE_BUILD_TYPE)
   set(cmake_build_type_undefined 1)
@@ -138,26 +138,23 @@
 
 option(SDLMIXER_MOD "Support loading MOD music" ON)
 
-cmake_dependent_option(SDLMIXER_MOD_MODPLUG "Support loading MOD music via modplug" OFF SDLMIXER_MOD OFF)
-cmake_dependent_option(SDLMIXER_MOD_MODPLUG_SHARED "Dynamically load modplug" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_MOD_MODPLUG OFF)
-
 cmake_dependent_option(SDLMIXER_MOD_XMP "Support loading MOD music via libxmp" ON SDLMIXER_MOD OFF)
 cmake_dependent_option(SDLMIXER_MOD_XMP_LITE "Use libxmp-lite instead of libxmp" OFF "SDLMIXER_MOD_XMP;NOT SDLMIXER_VENDORED" OFF)
 cmake_dependent_option(SDLMIXER_MOD_XMP_SHARED "Dynamically load libxmp(-lite)" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_MOD_XMP OFF)
 
-if(SDLMIXER_MOD AND NOT (SDLMIXER_MOD_MODPLUG OR SDLMIXER_MOD_XMP))
-    message(FATAL_ERROR "MOD support was enabled (SDLMIXER_MOD) but neither modplug (SDLMIXER_MOD_MODPLUG) or xmp (SDLMIXER_MOD_XMP) was enabled.")
+if(SDLMIXER_MOD AND NOT SDLMIXER_MOD_XMP)
+    message(FATAL_ERROR "MOD support was enabled (SDLMIXER_MOD) but xmp (SDLMIXER_MOD_XMP) was disabled.")
 endif()
 
 option(SDLMIXER_MP3 "Enable MP3 music" ON)
 
-cmake_dependent_option(SDLMIXER_MP3_MINIMP3 "Support loading MP3 music via minimp3" ON SDLMIXER_MP3 OFF)
+cmake_dependent_option(SDLMIXER_MP3_DRMP3 "Support loading MP3 music via dr_mp3" ON SDLMIXER_MP3 OFF)
 
 cmake_dependent_option(SDLMIXER_MP3_MPG123 "Support loading MP3 music via MPG123" OFF SDLMIXER_MP3 OFF)
 cmake_dependent_option(SDLMIXER_MP3_MPG123_SHARED "Dynamically load mpg123" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_MP3_MPG123 OFF)
 
-if(SDLMIXER_MP3 AND NOT (SDLMIXER_MP3_MINIMP3 OR SDLMIXER_MP3_MPG123))
-    message(FATAL_ERROR "MP3 support was enabled (SDLMIXER_MP3) but neither minimp3 (SDLMIXER_MP3_MINIMP3) or mpg123 (SDLMIXER_MP3_MPG123) were enabled.")
+if(SDLMIXER_MP3 AND NOT (SDLMIXER_MP3_DRMP3 OR SDLMIXER_MP3_MPG123))
+    message(FATAL_ERROR "MP3 support was enabled (SDLMIXER_MP3) but neither drmp3 (SDLMIXER_MP3_DRMP3) or mpg123 (SDLMIXER_MP3_MPG123) were enabled.")
 endif()
 
 option(SDLMIXER_MIDI "Enable MIDI music" ON)
@@ -254,11 +251,10 @@
     src/codecs/load_sndfile.c
     src/codecs/mp3utils.c
     src/codecs/music_drflac.c
+    src/codecs/music_drmp3.c
     src/codecs/music_flac.c
     src/codecs/music_fluidsynth.c
     src/codecs/music_gme.c
-    src/codecs/music_minimp3.c
-    src/codecs/music_modplug.c
     src/codecs/music_mpg123.c
     src/codecs/music_nativemidi.c
     src/codecs/music_ogg.c
@@ -289,3 +285,11 @@
 )
 target_compile_definitions(${sdl3_mixer_target_name} PRIVATE
     BUILD_SDL
+    SDL_BUILD_MAJOR_VERSION=${MAJOR_VERSION}
+    SDL_BUILD_MINOR_VERSION=${MINOR_VERSION}
+    SDL_BUILD_MICRO_VERSION=${MICRO_VERSION}
+)
+target_link_libraries(${sdl3_mixer_target_name} PUBLIC SDL3::Headers)
+if(SDLMIXER_BUILD_SHARED_LIBS)
+    target_link_libraries(${sdl3_mixer_target_name} PRIVATE SDL3::SDL3-shared)
+endif()

=== debian/changelog ===
libsdl3-mixer (3~git20250610~30c1301+ds-1) experimental; urgency=medium

  * New upstream snapshot

 -- Simon McVittie <smcv@debian.org>  Thu, 12 Jun 2025 11:38:37 +0100

libsdl3-mixer (3~git20250523~daf0503+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/p/mpg123-Use-portable-API-from-v1.32-if-available.patch:
    Drop patch, hopefully no longer needed (and it didn't work as I'd
    hoped anyway)

 -- Simon McVittie <smcv@debian.org>  Sat, 24 May 2025 13:54:03 +0100

libsdl3-mixer (3~git20250514~37b69a0+ds-2) experimental; urgency=medium

  * d/p/mpg123-Use-portable-API-from-v1.32-if-available.patch:
    Add proposed patch to fix the build on 32-bit non-i386, such as armhf

 -- Simon McVittie <smcv@debian.org>  Fri, 16 May 2025 17:59:00 +0100

libsdl3-mixer (3~git20250514~37b69a0+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/libsdl3-mixer-tests.install: Update for new snapshot.
    The manual tests are now installed to the same path we use, so we don't
    need to redirect them there from /usr/bin.

 -- Simon McVittie <smcv@debian.org>  Fri, 16 May 2025 09:47:24 +0100

libsdl3-mixer (3~git20250404~68764f3+ds-1) experimental; urgency=medium

  * New upstream snapshot
    - Please note that this snapshot includes incompatible ABI changes
  * d/copyright: Update
  * d/rules: Disable drmp3 instead of minimp3
  * d/rules: Stop disabling modplug support, no longer implemented
  * d/control: Add a note about the ABI not being stable (see #1095066)
  * Standards-Version: 4.7.2 (no changes required)

 -- Simon McVittie <smcv@debian.org>  Tue, 08 Apr 2025 11:05:47 +0100

libsdl3-mixer (3~git20250302~78a2035+ds-1) experimental; urgency=medium

  * New upstream snapshot

 -- Simon McVittie <smcv@debian.org>  Mon, 03 Mar 2025 09:46:51 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian SDL packages maintainers <pkg-sdl-maintainers@lists.alioth.debian.org>
 Uploaders: Manuel A. Fernandez Montecelo <mafm@debian.org>, Simon McVittie <smcv@debian.org>
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Build-Depends: cmake,
                debhelper-compat (= 13),
@@ -31,6 +31,9 @@
  channel of music, in various formats including FLAC, Ogg Vorbis, Opus, MP3 and
  WAV.
  .
+ This library does not yet have a stable ABI. Other packages in Debian
+ should not depend on it until its first upstream stable release (3.2.0).
+ .
  This package contains the shared library.
 
 Package: libsdl3-mixer-dev
@@ -51,6 +54,9 @@
  channel of music, in various formats including FLAC, Ogg Vorbis, Opus, MP3 and
  WAV.
  .
+ This library does not yet have a stable ABI. Other packages in Debian
+ should not depend on it until its first upstream stable release (3.2.0).
+ .
  This package contains the development files.
 
 Package: libsdl3-mixer-doc
@@ -65,6 +71,9 @@
  number of simultaneously playing channels of 16 bit stereo audio, plus a single
  channel of music, in various formats including FLAC, Ogg Vorbis, Opus, MP3 and
  WAV.
+ .
+ This library does not yet have a stable ABI. Other packages in Debian
+ should not depend on it until its first upstream stable release (3.2.0).
  .
  This package contains the reference manual and examples.

=== debian/rules ===
--- 
+++ 
@@ -15,7 +15,7 @@
 built_binaries := $(shell dh_listpackages)
 
 ifneq (,$(filter-out experimental UNRELEASED,$(DEB_DISTRIBUTION)))
-$(error This version of SDL_image is not yet suitable for testing/unstable)
+$(error This version of SDL_mixer is not yet suitable for testing/unstable)
 endif
 
 confflags :=
@@ -59,13 +59,12 @@
 # previously enabled format, so initially turn off soundtracker playback
 # for the SDL3 branch.
 confflags += -DSDLMIXER_MOD=OFF
-confflags += -DSDLMIXER_MOD_MODPLUG=OFF
 confflags += -DSDLMIXER_MOD_XMP=OFF
 confflags += -DSDLMIXER_MOD_XMP_LITE=OFF
 
 confflags += -DSDLMIXER_MP3=ON
+confflags += -DSDLMIXER_MP3_DRMP3=OFF
 confflags += -DSDLMIXER_MP3_MPG123=ON
-confflags += -DSDLMIXER_MP3_MINIMP3=OFF
 
 confflags += -DSDLMIXER_OPUS=ON
 confflags += -DSDLMIXER_SNDFILE=OFF

## libsdl3-mixer 3.1~git20250829~b0503d2+ds

=== debian/changelog ===
libsdl3-mixer (3.1~git20250829~b0503d2+ds-1) experimental; urgency=medium

  * New upstream snapshot with major API/ABI changes
  * Update autopkgtest for new package
  * d/libsdl3-mixer0.symbols: Rewrite for new ABI
  * d/copyright: Update
  * d/control: Require a correspondly recent SDL3 snapshot
  * Update packaging for upstream changes to documentation/examples

 -- Simon McVittie <smcv@debian.org>  Thu, 04 Sep 2025 09:43:59 +0100

## libsdl3-mixer 3.1~git20250910~d032535+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,9 +8,9 @@
 
 # See docs/release_checklist.md
 set(MAJOR_VERSION 3)
-set(MINOR_VERSION 0)
+set(MINOR_VERSION 1)
 set(MICRO_VERSION 0)
-set(SDL_REQUIRED_VERSION 3.0.0)
+set(SDL_REQUIRED_VERSION 3.3.0)
 
 project(SDL3_mixer
     LANGUAGES C
@@ -49,11 +49,6 @@
   endif()
 endif()
 
-set(SDLMIXER_SAMPLES_DEFAULT ${SDLMIXER_ROOTPROJECT})
-if(ANDROID)
-    set(SDLMIXER_SAMPLES_DEFAULT OFF)
-endif()
-
 # option() honors normal variables.
 cmake_policy(SET CMP0077 NEW)
 set(CMAKE_POLICY_DEFAULT_CMP0077 NEW)
@@ -120,90 +115,53 @@
   set(fatal_error "FATAL_ERROR")
 endif()
 
-option(SDLMIXER_SAMPLES "Build the SDL3_mixer sample program(s)" ${SDLMIXER_SAMPLES_DEFAULT})
-cmake_dependent_option(SDLMIXER_SAMPLES_INSTALL "Install the SDL3_mixer sample program(s)" OFF "SDLMIXER_SAMPLES;SDLMIXER_INSTALL" OFF)
-
-option(SDLMIXER_SNDFILE "Support loading sounds via libsndfile" OFF)
-option(SDLMIXER_SNDFILE_SHARED "Dynamically load libsndfile" "${SDLMIXER_DEPS_SHARED}")
-
-option(SDLMIXER_FLAC "Enable FLAC music" ON)
-
-cmake_dependent_option(SDLMIXER_FLAC_LIBFLAC "Enable FLAC music using libFLAC" OFF SDLMIXER_FLAC OFF)
+option(SDLMIXER_TESTS "Build unit tests?" OFF)
+option(SDLMIXER_TESTS_INSTALL "Install unit tests?" OFF)
+
+# These are implemented in SDL_mixer itself, not using a third-party library.
+option(SDLMIXER_AIFF "Enable AIFF audio" ON)
+option(SDLMIXER_WAVE "Enable WAVE audio" ON)
+option(SDLMIXER_VOC "Enable VOC audio" ON)
+option(SDLMIXER_AU "Enable AU audio" ON)
+
+# Decoders that use third-party dependencies, even if they are compiled in, vendored, etc.
+option(SDLMIXER_FLAC_LIBFLAC "Enable FLAC audio using libFLAC" ON)
 cmake_dependent_option(SDLMIXER_FLAC_LIBFLAC_SHARED "Dynamically load LIBFLAC" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_FLAC_LIBFLAC OFF)
 
-cmake_dependent_option(SDLMIXER_FLAC_DRFLAC "Enable FLAC music using drflac" ON SDLMIXER_FLAC OFF)
-
-option(SDLMIXER_GME "Support loading GME music via game-music-emu" ON)
+option(SDLMIXER_FLAC_DRFLAC "Enable FLAC audio using drflac" ON)
+
+option(SDLMIXER_GME "Support loading GME audio via game-music-emu" ON)
 option(SDLMIXER_GME_SHARED "Dynamically load libgme" "${SDLMIXER_DEPS_SHARED}")
 
-option(SDLMIXER_MOD "Support loading MOD music" ON)
-
-cmake_dependent_option(SDLMIXER_MOD_XMP "Support loading MOD music via libxmp" ON SDLMIXER_MOD OFF)
+option(SDLMIXER_MOD_XMP "Support loading MOD audio via libxmp" ON)
 cmake_dependent_option(SDLMIXER_MOD_XMP_LITE "Use libxmp-lite instead of libxmp" OFF "SDLMIXER_MOD_XMP;NOT SDLMIXER_VENDORED" OFF)
 cmake_dependent_option(SDLMIXER_MOD_XMP_SHARED "Dynamically load libxmp(-lite)" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_MOD_XMP OFF)
 
-if(SDLMIXER_MOD AND NOT SDLMIXER_MOD_XMP)
-    message(FATAL_ERROR "MOD support was enabled (SDLMIXER_MOD) but xmp (SDLMIXER_MOD_XMP) was disabled.")
-endif()
-
-option(SDLMIXER_MP3 "Enable MP3 music" ON)
-
-cmake_dependent_option(SDLMIXER_MP3_DRMP3 "Support loading MP3 music via dr_mp3" ON SDLMIXER_MP3 OFF)
-
-cmake_dependent_option(SDLMIXER_MP3_MPG123 "Support loading MP3 music via MPG123" OFF SDLMIXER_MP3 OFF)
+option(SDLMIXER_MP3_DRMP3 "Support loading MP3 audio via dr_mp3" ON)
+option(SDLMIXER_MP3_MPG123 "Support loading MP3 audio via libmpg123" ON)
 cmake_dependent_option(SDLMIXER_MP3_MPG123_SHARED "Dynamically load mpg123" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_MP3_MPG123 OFF)
 
-if(SDLMIXER_MP3 AND NOT (SDLMIXER_MP3_DRMP3 OR SDLMIXER_MP3_MPG123))
-    message(FATAL_ERROR "MP3 support was enabled (SDLMIXER_MP3) but neither drmp3 (SDLMIXER_MP3_DRMP3) or mpg123 (SDLMIXER_MP3_MPG123) were enabled.")
-endif()
-
-option(SDLMIXER_MIDI "Enable MIDI music" ON)
-
-cmake_dependent_option(SDLMIXER_MIDI_FLUIDSYNTH "Support FluidSynth MIDI output" ON "SDLMIXER_MIDI;NOT SDLMIXER_VENDORED" OFF)
+cmake_dependent_option(SDLMIXER_MIDI_FLUIDSYNTH "Support FluidSynth MIDI output" ON "NOT SDLMIXER_VENDORED" OFF)
 cmake_dependent_option(SDLMIXER_MIDI_FLUIDSYNTH_SHARED "Dynamically load libfluidsynth" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_MIDI_FLUIDSYNTH OFF)
 
-if(WIN32 OR APPLE OR HAIKU OR "${CMAKE_SYSTEM_NAME}" MATCHES "Linux")
-    cmake_dependent_option(SDLMIXER_MIDI_NATIVE "Support native MIDI output" ON SDLMIXER_MIDI OFF)
-else()
-    set(SDLMIXER_MIDI_NATIVE OFF)
-endif()
-
-cmake_dependent_option(SDLMIXER_MIDI_TIMIDITY "Support timidity MIDI output" ON SDLMIXER_MIDI OFF)
-
-if(SDLMIXER_MIDI AND NOT (SDLMIXER_MIDI_TIMIDITY OR SDLMIXER_MIDI_NATIVE OR SDLMIXER_MIDI_FLUIDSYNTH))
-    message(FATAL_ERROR "MIDI support was enabled (SDLMIXER_MIDI) but neither FluidSynth (SDLMIXER_MIDI_FLUIDSYNTH), native (SDLMIXER_MIDI_NATIVE) or timidity (SDLMIXER_MIDI_TIMIDITY) was enabled")
-endif()
-
-option(SDLMIXER_OPUS "Enable Opus music" ON)
+option(SDLMIXER_MIDI_TIMIDITY "Support timidity MIDI output" ON)
+
+option(SDLMIXER_OPUS "Enable Opus audio via libopus" ON)
 cmake_dependent_option(SDLMIXER_OPUS_SHARED "Dynamically load libopus" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_OPUS OFF)
 
-set(sdl3mixer_vorbis_strings STB TREMOR VORBISFILE)
-set(SDLMIXER_VORBIS "STB" CACHE STRING "Enable OGG Vorbis music")
-set_property(CACHE SDLMIXER_VORBIS PROPERTY STRINGS "${sdl3mixer_vorbis_strings}")
-if(SDLMIXER_VORBIS)
-    if(NOT SDLMIXER_VORBIS IN_LIST sdl3mixer_vorbis_strings)
-        message(FATAL_ERROR "SDLMIXER_VORBIS contains an invalid value (=${SDLMIXER_VORBIS}). It must be one of ${sdl3mixer_vorbis_strings}.")
-    endif()
-endif()
-set(SDLMIXER_VORBIS_STB OFF)
-set(SDLMIXER_VORBIS_TREMOR OFF)
-set(SDLMIXER_VORBIS_VORBISFILE OFF)
-if(SDLMIXER_VORBIS STREQUAL "STB")
-    set(SDLMIXER_VORBIS_STB ON)
-endif()
-if(SDLMIXER_VORBIS STREQUAL "TREMOR")
-    set(SDLMIXER_VORBIS_TREMOR ON)
-endif()
-if(SDLMIXER_VORBIS STREQUAL "VORBISFILE")
-    set(SDLMIXER_VORBIS_VORBISFILE ON)
-endif()
-cmake_dependent_option(SDLMIXER_VORBIS_TREMOR_SHARED "Dynamically load tremor library" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_VORBIS_TREMOR OFF)
+option(SDLMIXER_VORBIS_STB "Enable Ogg Vorbis audio via stb_vorbis" ON)
+option(SDLMIXER_VORBIS_VORBISFILE "Enable Ogg Vorbis audio via libvorbisfile" ON)
+option(SDLMIXER_VORBIS_TREMOR "Enable Ogg Vorbis audio via libvorbisidec ('tremor')" OFF)
+
+if (SDLMIXER_VORBIS_VORBISFILE AND SDLMIXER_VORBIS_TREMOR)
+    message(FATAL_ERROR "Both SDLMIXER_VORBIS_VORBISFILE and SDLMIXER_VORBIS_TREMOR are both enabled, but only one can be used")
+endif()
+
 cmake_dependent_option(SDLMIXER_VORBIS_VORBISFILE_SHARED "Dynamically load vorbisfile library" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_VORBIS_VORBISFILE OFF)
-
-option(SDLMIXER_WAVE "Enable streaming WAVE music" ON)
-
-option(SDLMIXER_WAVPACK "Enable WavPack music" ON)
-cmake_dependent_option(SDLMIXER_WAVPACK_DSD "Enable WavPack DSD music support" OFF SDLMIXER_WAVPACK OFF)
+cmake_dependent_option(SDLMIXER_VORBIS_TREMOR_SHARED "Dynamically load vorbisidec ('tremor') library" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_VORBIS_TREMOR OFF)
+
+option(SDLMIXER_WAVPACK "Enable WavPack audio" ON)
+cmake_dependent_option(SDLMIXER_WAVPACK_DSD "Enable WavPack DSD audio support" OFF SDLMIXER_WAVPACK OFF)
 cmake_dependent_option(SDLMIXER_WAVPACK_SHARED "Dynamically load WavPack library" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_WAVPACK OFF)
 
 if(SDLMIXER_VORBIS_TREMOR OR SDLMIXER_VORBIS_VORBISFILE OR SDLMIXER_FLAC_LIBFLAC OR SDLMIXER_OPUS)
@@ -246,34 +204,36 @@
 
 set(BUILD_SHARED_LIBS ${SDLMIXER_BUILD_SHARED_LIBS})
 add_library(${sdl3_mixer_target_name}
-    src/codecs/load_aiff.c
-    src/codecs/load_voc.c
-    src/codecs/load_sndfile.c
-    src/codecs/mp3utils.c
-    src/codecs/music_drflac.c
-    src/codecs/music_drmp3.c
-    src/codecs/music_flac.c
-    src/codecs/music_fluidsynth.c
-    src/codecs/music_gme.c
-    src/codecs/music_mpg123.c
-    src/codecs/music_nativemidi.c
-    src/codecs/music_ogg.c
-    src/codecs/music_ogg_stb.c
-    src/codecs/music_opus.c
-    src/codecs/music_timidity.c
-    src/codecs/music_wav.c
-    src/codecs/music_wavpack.c
-    src/codecs/music_xmp.c
-    src/effect_position.c
-    src/effect_stereoreverse.c
-    src/effects_internal.c
-    src/mixer.c
-    src/music.c
-    src/utils.c
+    src/SDL_mixer.c
+    src/SDL_mixer_metadata_tags.c
+    src/SDL_mixer_spatialization.c
+    src/decoder_aiff.c
+    src/decoder_au.c
+    src/decoder_drflac.c
+    src/decoder_drmp3.c
+    src/decoder_flac.c
+    src/decoder_fluidsynth.c
+    src/decoder_gme.c
+    src/decoder_mpg123.c
+    src/decoder_opus.c
+    src/decoder_raw.c
+    src/decoder_sinewave.c
+    src/decoder_stb_vorbis.c
+    src/decoder_timidity.c
+    src/decoder_voc.c
+    src/decoder_vorbis.c
+    src/decoder_wav.c
+    src/decoder_wavpack.c
+    src/decoder_xmp.c
 )
 add_library(SDL3_mixer::${sdl3_mixer_target_name} ALIAS ${sdl3_mixer_target_name})
 if(NOT TARGET SDL3_mixer::SDL3_mixer)
     add_library(SDL3_mixer::SDL3_mixer ALIAS ${sdl3_mixer_target_name})
+endif()
+if("c_std_99" IN_LIST CMAKE_C_COMPILE_FEATURES)
+    target_compile_features(${sdl3_mixer_target_name} PRIVATE c_std_99)
+else()
+    message(WARNING "target_compile_features does not know c_std_99 for C compiler")
 endif()
 target_include_directories(${sdl3_mixer_target_name}
     PUBLIC
@@ -293,3 +253,52 @@
 if(SDLMIXER_BUILD_SHARED_LIBS)
     target_link_libraries(${sdl3_mixer_target_name} PRIVATE SDL3::SDL3-shared)
 endif()
+sdl_add_warning_options(${sdl3_mixer_target_name} WARNING_AS_ERROR ${SDLMIXER_WERROR})
+if(WIN32 AND BUILD_SHARED_LIBS)
+    target_sources(${sdl3_mixer_target_name} PRIVATE
+        src/version.rc
+    )
+    if(MINGW)
+        target_link_options(${sdl3_mixer_target_name} PRIVATE -static-libgcc)
+    endif()
+endif()
+set_target_properties(${sdl3_mixer_target_name} PROPERTIES
+    OUTPUT_NAME "SDL3_mixer"
+    DEFINE_SYMBOL DLL_EXPORT
+    EXPORT_NAME ${sdl3_mixer_target_name}
+    C_VISIBILITY_PRESET "hidden"
+)
+
+sdl_target_link_option_version_file(${sdl3_mixer_target_name} "${CMAKE_CURRENT_SOURCE_DIR}/src/SDL_mixer.sym")
+
+if(NOT ANDROID)
+    set_target_properties(${sdl3_mixer_target_name} PROPERTIES
+        SOVERSION "${SO_VERSION_MAJOR}"
+        VERSION "${SO_VERSION}"
+    )
+    if(APPLE)
+        cmake_minimum_required(VERSION 3.17...3.28)
+        set_target_properties(${sdl3_mixer_target_name} PROPERTIES
+            MACHO_COMPATIBILITY_VERSION "${DYLIB_COMPAT_VERSION}"
+            MACHO_CURRENT_VERSION "${DYLIB_CURRENT_VERSION}"
+        )
+    endif()
+endif()
+if(SDLMIXER_BUILD_SHARED_LIBS)
+    if(WIN32)
+        set_target_properties(${sdl3_mixer_target_name} PROPERTIES
+            PREFIX ""
+            DLL_NAME_WITH_SOVERSION FALSE
+        )
+    endif()
+else()
+    if(MSVC)
+        set_target_properties(${sdl3_mixer_target_name} PROPERTIES
+            OUTPUT_NAME "SDL3_mixer-static"
+        )
+    endif()
+endif()
+
+# Use `Compatible Interface Properties` to ensure a shared SDL3_mixer is linked to a shared SDL3 library
+if(SDLMIXER_BUILD_SHARED_LIBS)
+    set_property(TARGET ${sdl3_mixer_target_name} PROPERTY INTERFACE_SDL3_SHARED ${SDLMIXER_BUILD_SHARED_LIBS})

=== debian/changelog ===
libsdl3-mixer (3.1~git20250910~d032535+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/libsdl3-mixer0.symbols: Update

 -- Simon McVittie <smcv@debian.org>  Thu, 11 Sep 2025 09:51:44 +0100

=== debian/watch ===
version=4

opts="\
    mode=git, \
    compression=gzip, \
    dversionmangle=s/\+(?:git)?[0-9]*(?:\+g[0-9a-f]*)(?:\+(?:dfsg|ds)[0-9]*)//, \
    pretty=3.1~git%cd~%h+ds" \
https://github.com/libsdl-org/SDL_mixer \
HEAD
